/**
 */
package SA;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port Instance</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link SA.PortInstance#getName <em>Name</em>}</li>
 *   <li>{@link SA.PortInstance#getConnect <em>Connect</em>}</li>
 *   <li>{@link SA.PortInstance#getOutComponent <em>Out Component</em>}</li>
 *   <li>{@link SA.PortInstance#getInComponent <em>In Component</em>}</li>
 *   <li>{@link SA.PortInstance#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see SA.SAPackage#getPortInstance()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='ExactlyOneConnector ExactlyOneComponent'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot ExactlyOneConnector='self.connect->size() = 1' ExactlyOneComponent='self.outComponent->size() + self.inComponent->size() = 1'"
 * @generated
 */
public interface PortInstance extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see SA.SAPackage#getPortInstance_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link SA.PortInstance#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Connect</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link SA.Connector#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connect</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connect</em>' reference.
	 * @see #setConnect(Connector)
	 * @see SA.SAPackage#getPortInstance_Connect()
	 * @see SA.Connector#getPort
	 * @model opposite="port"
	 * @generated
	 */
	Connector getConnect();

	/**
	 * Sets the value of the '{@link SA.PortInstance#getConnect <em>Connect</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connect</em>' reference.
	 * @see #getConnect()
	 * @generated
	 */
	void setConnect(Connector value);

	/**
	 * Returns the value of the '<em><b>Out Component</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link SA.ComponentInstance#getOutPorts <em>Out Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Out Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Out Component</em>' container reference.
	 * @see #setOutComponent(ComponentInstance)
	 * @see SA.SAPackage#getPortInstance_OutComponent()
	 * @see SA.ComponentInstance#getOutPorts
	 * @model opposite="outPorts" transient="false"
	 * @generated
	 */
	ComponentInstance getOutComponent();

	/**
	 * Sets the value of the '{@link SA.PortInstance#getOutComponent <em>Out Component</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Out Component</em>' container reference.
	 * @see #getOutComponent()
	 * @generated
	 */
	void setOutComponent(ComponentInstance value);

	/**
	 * Returns the value of the '<em><b>In Component</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link SA.ComponentInstance#getInPorts <em>In Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>In Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>In Component</em>' container reference.
	 * @see #setInComponent(ComponentInstance)
	 * @see SA.SAPackage#getPortInstance_InComponent()
	 * @see SA.ComponentInstance#getInPorts
	 * @model opposite="inPorts" transient="false"
	 * @generated
	 */
	ComponentInstance getInComponent();

	/**
	 * Sets the value of the '{@link SA.PortInstance#getInComponent <em>In Component</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>In Component</em>' container reference.
	 * @see #getInComponent()
	 * @generated
	 */
	void setInComponent(ComponentInstance value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link SA.PortType#getPort_instance <em>Port instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' reference.
	 * @see #setType(PortType)
	 * @see SA.SAPackage#getPortInstance_Type()
	 * @see SA.PortType#getPort_instance
	 * @model opposite="port_instance" required="true"
	 * @generated
	 */
	PortType getType();

	/**
	 * Sets the value of the '{@link SA.PortInstance#getType <em>Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' reference.
	 * @see #getType()
	 * @generated
	 */
	void setType(PortType value);

} // PortInstance
